package com.gic.plug.web.controller.goods;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.util.PageHelperUtils;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.goods.api.dto.ErrorCode;
import com.gic.goods.api.dto.GoodsTagDTO;
import com.gic.goods.api.service.TagApiService;
import com.gic.plug.web.vo.goods.GoodsTagVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
  * @ClassName: GoodsTagController
  * @Description: 商品标签相关接口
  * @author xub
  * @date 2019/8/29 上午10:03
  */
@RestController
public class GoodsTagController extends BaseGoodsController {

    @Autowired
    private TagApiService tagApiService;

    /**
     * @Description: 查询所有（不分页）
     * @author xub
     */
    @GetMapping("list-tag")
    public RestResponse findList(@RequestParam(value = "currentPage", defaultValue = "1") Integer currentPage,
                                 @RequestParam(value = "pageSize", defaultValue = "20") Integer pageSize, Long goodsDomainId) {
        if (goodsDomainId == null) {
            return RestResponse.failure(ErrorCode.UNKNOW_ERROR.getCode(), "参数不全");
        }

        ServiceResponse<Page<GoodsTagDTO>> serviceResponse = tagApiService.listByPage(currentPage, pageSize,
                goodsDomainId, getEnterpriseId());
        Page<GoodsTagVO> voPage = PageHelperUtils.changePageToCurrentPage(serviceResponse.getResult(),
                GoodsTagVO.class);
        return RestResponse.success(voPage);
    }
}
