package com.gic.plug.web.strategy.impl;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.plug.web.strategy.ScreenBackStrategy;
import com.gic.plug.web.utils.ComputeBackUtil;
import com.gic.store.constant.StoreESFieldsEnum;
import com.gic.store.dto.StoreGroupDTO;
import com.gic.store.dto.StoreTagDTO;
import com.gic.store.service.StoreTagApiService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

@Component
public class StoreTagBackImpl implements ScreenBackStrategy {
    @Autowired
    private StoreTagApiService storeTagApiService;
    @Override
    public String screenBack(String compute, String value, String key, Integer enterpriseId) {
        if(StringUtils.isNotBlank(value)){
            StringBuilder stringBuilder = new StringBuilder(StoreESFieldsEnum.STORETAG.getDesc()).append(" ");
            stringBuilder.append(ComputeBackUtil.getComputeBack(compute)).append(" ");
            String[] valueArr = value.split(" ");
            for(String s : valueArr){
                ServiceResponse<StoreTagDTO> response = this.storeTagApiService.getByStoreTagId(Integer.valueOf(s));
                if(response.isSuccess() && response.getResult()!= null){
                    stringBuilder.append("【").append(response.getResult().getStoreTagName()).append("】").append(" ");
                }
            }
            return stringBuilder.toString();
        }
        return null;
    }
}
