package com.gic.plug.web.utils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.enterprise.utils.UserDetail;
import com.gic.enterprise.utils.UserDetailUtils;
import com.gic.store.constant.StoreESFieldsEnum;
import com.gic.store.dto.StoreWidgetDTO;
import com.gic.store.service.StoreWidgetApiService;
import org.apache.commons.collections.CollectionUtils;

import java.util.HashSet;
import java.util.Set;

public class StoreRegionAuthUtil {
    public static Set<String> getUserRegion(StoreWidgetApiService storeWidgetApiService){
        Set<String> authRegionSet = new HashSet<>();
        UserDetail userDetail = UserDetailUtils.getUserDetail();
        if(userDetail.getUserInfo().getSuperAdmin() != 1 && userDetail.getUserResourceInfo() != null){
            Long storeResource = userDetail.getUserResourceInfo().getStoreResource();
            if(storeResource != null){
                ServiceResponse<StoreWidgetDTO> storeWidget = storeWidgetApiService.getStoreWidget(storeResource.intValue());
                if(storeWidget.getResult() != null){
                    String searchParam = storeWidget.getResult().getSearchParam();
                    JSONObject json = JSON.parseArray(searchParam).getJSONObject(0);
                    JSONArray list = json.getJSONArray("list");
                    for(int i=0; i< list.size(); i++){
                        JSONObject o = list.getJSONObject(i).getJSONObject("data");
                        if(o.getString("key").equals(StoreESFieldsEnum.REGIONID.getField())){
                            String[] arr = o.getString("value").split(" ");
                            Set<String> set = new HashSet<>();
                            for(String s : arr){
                                set.add(s);
                            }
                            authRegionSet.addAll(set);
                        }
                    }
                }
            }
            if(CollectionUtils.isEmpty(authRegionSet)){
                authRegionSet.add("-1");
            }
        }
        return authRegionSet;
    }
}
